print("MicroMenu, Bags and Tooltip Mover loaded ! Type /MMBT for settings")

-- Variable
local event = CreateFrame("Frame")
local MMBTsettings

local HideBagsBar 
local MicroMenuMO -- false (CheckButton unchecked) = Mouse Over Disable
local tooltipTest

-- Table with micro menu button
local micro_button = {
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	LFDMicroButton,
	CollectionsMicroButton,
	EJMicroButton,
	StoreMicroButton,
	MainMenuMicroButton
}

-- Function create settings frame
function MMBT_settings_frame()
	-- Main frame
	MMBTsettings = CreateFrame("Frame", "MMBTsettings", UIParent, "UIPanelDialogTemplate")
	MMBTsettings:SetPoint("CENTER", 0, 0)
	MMBTsettings:SetSize(300, 168)
	MMBTsettings:SetMovable(true) -- Drag and drop option's
	MMBTsettings:EnableMouse(true) -- Drag and drop option's
	MMBTsettings:RegisterForDrag("LeftButton") -- Drag and drop option's
	MMBTsettings:SetScript("OnDragStart", MMBTsettings.StartMoving) -- Drag and drop option's
	MMBTsettings:SetScript("OnDragStop", MMBTsettings.StopMovingOrSizing) -- Drag and drop option's

	-- Create settings frame title
	MMBTsettings.title = MMBTsettings:CreateFontString(nil, "OVERLAY")
	MMBTsettings.title:ClearAllPoints()
	MMBTsettings.title:SetFontObject("GameFontHighlight")
	MMBTsettings.title:SetPoint("TOPLEFT", 12, -8)
	MMBTsettings.title:SetText("MicroMenuAndBags Settings")

	-- Button Move bar
	MMBTsettings.MoveBarButton = MMBT_CreateCheckButton(MMBTsettings, MoveBarButton, 12, -30)
	MMBTsettings.MoveBarButtonText = MMBT_CreateText(MMBTsettings, MicroMenuMouseOver, 50, -42, "Move bars")

	-- Button Hide/Show Bag
	MMBTsettings.HideBagsButton = MMBT_CreateCheckButton(MMBTsettings, HideBagsButton, 12, -60)
	MMBTsettings.HideBagsButtonText = MMBT_CreateText(MMBTsettings, HideBagsButtonText, 50, -72, "Hide bags bar")

	-- Button Mouse Over Micro Menu
	MMBTsettings.MicroMenuButton = MMBT_CreateCheckButton(MMBTsettings, MicroMenuButton, 12, -90)
	MMBTsettings.MicroMenuMouseOver = MMBT_CreateText(MMBTsettings, MicroMenuMouseOver, 50, -102, "Enable micro menu mouseover")
	
	-- Button Move tooltip
	MMBTsettings.MoveTooltipButton = MMBT_CreateCheckButton(MMBTsettings, MoveTooltipButton, 12 , -120)
	MMBTsettings.MoveTooltipButtonText = MMBT_CreateText(MMBTsettings, MoveTooltipButtonText, 50, -132, "Move tooltip")

	-- Check / uncheck checkbutton when player open settings frame with sv info
	MMBT_loadSettingsCheckButton(HideBagsBar, MMBTsettings.HideBagsButton)
	MMBT_loadSettingsCheckButton(MicroMenuMO, MMBTsettings.MicroMenuButton)

	if MMBTsettings.HideBagsButton:GetChecked() then
		MMBTsettings.MoveBarButton:Disable()
	else
		MMBTsettings.MoveBarButton:Enable()
	end

	-- Function
	-- Hide / Show Bags bar when user click on checkbutton
	MMBTsettings.HideBagsButton:SetScript("OnClick",
	function()
		if MMBTsettings.HideBagsButton:GetChecked() == true then
			HideBagsBar = true
			MicroButtonAndBagsBar:Hide()
			MMBTsettings.MoveBarButton:Disable()
		else
			HideBagsBar = false
			MicroButtonAndBagsBar:Show()
			MMBTsettings.MoveBarButton:Enable()
		end
	end)

	-- Enable Micro Menu Mouseover
	MMBTsettings.MicroMenuButton:SetScript("OnClick", 
	function()
		if MMBTsettings.MicroMenuButton:GetChecked() == true then
			MicroMenuMO = true
			MMBT_Micro_Button_Transparency(0)
		else
			MicroMenuMO = false
			MMBT_Micro_Button_Transparency(1)
		end
	end)

	-- Unlock bars for moving
	MMBTsettings.MoveBarButton:SetScript("OnClick",
	function()
		if MMBTsettings.MoveBarButton:GetChecked() == true then
			-- Unlock bags bar and micro menu
			MMBT_unlockElement(MicroButtonAndBagsBar)
		else
			-- Lock bags bar and micro menu
			MMBT_lockElement(MicroButtonAndBagsBar)
			-- Save new position
			point, _, _, xPos, yPos = MMBT_getPos(MicroButtonAndBagsBar)
			MMBTSV[3] = point
			MMBTSV[4] = xPos
			MMBTSV[5] = yPos
		end
	end)

	-- Move tooltip
	MMBTsettings.MoveTooltipButton:SetScript("OnClick", 
	function()
		if MMBTsettings.MoveTooltipButton:GetChecked() == true then
			tooltipTest:Show()
		else
			tooltipTest:Hide()
		end
	end)

	MMBTsettings:Show()
end

function MMBT_CreateTooltipAnchor()
	tooltipTest = CreateFrame("Frame", "tooltipTest")
	tooltipTest:SetSize(180, 60)
	if MMBTSV[6] then
		tooltipTest:SetPoint(unpack(MMBTSV[6]))
	else
		tooltipTest:SetPoint("TOP")
	end

	tooltipTest.texture = tooltipTest:CreateTexture()
	tooltipTest.texture:SetAllPoints(tooltipTest)
	tooltipTest.texture:SetAlpha(0.5)
	tooltipTest.texture:SetTexture(1,1,1)

	-- Set frame movable
	tooltipTest:SetMovable(true) -- Drag and drop option's
	tooltipTest:EnableMouse(true) -- Drag and drop option's
	tooltipTest:RegisterForDrag("LeftButton") -- Drag and drop option's
	tooltipTest:SetScript("OnDragStart", tooltipTest.StartMoving) -- Drag and drop option's
	tooltipTest:SetScript("OnDragStop", tooltipTest.StopMovingOrSizing) -- Drag and drop option's
	tooltipTest:Hide()

    hooksecurefunc("GameTooltip_SetDefaultAnchor", MMBT_MTTToolTipHandler);

	tooltipTest:Hide()
end

function MMBT_MTTToolTipHandler(self)
    self:ClearAllPoints(true);
    self:SetPoint("BOTTOMRIGHT", tooltipTest, "BOTTOMRIGHT")
end

-- Function to modify Micro button transparency
function MMBT_Micro_Button_Transparency(transparency)
	for _, v in ipairs(micro_button) do
		v:SetAlpha(transparency)
	end
end

-- Create check button
function MMBT_CreateCheckButton(parent, children, btnX, btnY)
	parent.children = CreateFrame("CheckButton", children, parent, "ChatConfigCheckButtonTemplate")
	parent.children:SetPoint("TOPLEFT", btnX, btnY)
	parent.children:SetSize(40, 40)

	return parent.children
end

-- Create text
function MMBT_CreateText(parent, children, txtX, txtY, txt)
	parent.children = parent:CreateFontString(nil, "OVERLAY")
	parent.children:ClearAllPoints()
	parent.children:SetFontObject("GameFontHighlight")
	parent.children:SetPoint("TOPLEFT", txtX, txtY)
	parent.children:SetText(txt)

	return parent.children
end

-- load check button statue
function MMBT_loadSettingsCheckButton(var, frame)
	if var == true then
		frame:SetChecked(true)
	else
		frame:SetChecked(false)
	end
end

-- Unlock and enable drag and drop for wow element
function MMBT_unlockElement(parent)
	-- Create Texture
	parent.texture = parent:CreateTexture()
	parent.texture:SetAllPoints(parent)
	parent.texture:SetAlpha(0.5)
	parent.texture:SetTexture(1,1,1)

	-- Set frame movable
	parent:SetMovable(true) -- Drag and drop option's
	parent:EnableMouse(true) -- Drag and drop option's
	parent:RegisterForDrag("LeftButton") -- Drag and drop option's
	parent:SetScript("OnDragStart", parent.StartMoving) -- Drag and drop option's
	parent:SetScript("OnDragStop", parent.StopMovingOrSizing) -- Drag and drop option's
end

-- Lock and disable drag and drop for wow element
function MMBT_lockElement(parent)
	-- Remove Texture
	parent.texture:SetTexture(nil)

	-- Disable drag and drop
	parent:SetMovable(false)
	parent:EnableMouse(false)
end

-- Get Region Point
function MMBT_getPos(parent)
	return parent:GetPoint()
end

-- Set Region Point
function MMBT_setPos(parent, point, ofsx, ofsy)
	parent:ClearAllPoints()
	parent:SetPoint(point, nil, point, ofsx, ofsy)
end

do
	-- Function for MouseOver Micro menu
	for _, v in ipairs(micro_button) do
		v:HookScript("OnEnter", function() if MicroMenuMO == true then MMBT_Micro_Button_Transparency(1) end end)
		v:HookScript("OnLeave", function() if MicroMenuMO == true then MMBT_Micro_Button_Transparency(0) end end)
	end 
end

-- Slash Command for showing or create settings frame
SLASH_MMBT1 = "/MMBT";
SlashCmdList["MMBT"] = function(msg)
	if MMBTsettings == nil then
		MMBT_settings_frame()
	else
		MMBTsettings:Show()
	end
end

-- Events
event:SetScript("OnEvent", function(self, event, ...)
	if event == "ADDON_LOADED" then
		-- Create Table if not exist
		if not MMBTSV then
			MMBTSV = {
				[6] = {"CENTER", nil, "CENTER", 0, 0}
			}
		else -- Else init variable with sv info
			--Hide / Show Bags bar when player login
			HideBagsBar = MMBTSV[1]
			if HideBagsBar == true then
				MicroButtonAndBagsBar:Hide()
			else
				MicroButtonAndBagsBar:Show()
			end

			-- Enable / Disable Micro Menu Mouseover
			MicroMenuMO = MMBTSV[2]
			if MicroMenuMO == true then
				MMBT_Micro_Button_Transparency(0)
			else
				MMBT_Micro_Button_Transparency(1)
			end

			-- Set bags bar and micro menu positon
			if MMBTSV[3] ~= nil and MMBTSV[4] ~= nil then
				MMBT_setPos(MicroButtonAndBagsBar, MMBTSV[3], MMBTSV[4], MMBTSV[5])
			end
		end
		if tooltipTest == nil then
			MMBT_CreateTooltipAnchor()
		end
	end


	if event == "PLAYER_LOGOUT" then
		-- Saved info in sv
		MMBTSV[1] = HideBagsBar -- Bags Bar Statue
		MMBTSV[2] = MicroMenuMO -- Micro Menu Mouseover Statue
		MMBTSV[6] = { tooltipTest:GetPoint() }
	end
end)

event:RegisterEvent("ADDON_LOADED")
event:RegisterEvent("PLAYER_LOGOUT")